	TITLE ALGB Library Subroutine Module

INCLUDE alromid.h
INCLUDE alextdec.h

*****************************************************************
* The main module contains the subroutines for the user words.
* Each routine is named with a NULLNAME compiler directive, and
* has a corresponding entry in the external declarations file.
*****************************************************************
NULLNAME ERR$EVALext ( seco  -> action )
* Pour un # effectue :: SWAP NOTcase :: AL#MSG #+ DO#EXIT ; DROP ;
* Donc on peut faire un test puis # ERR$EVALext, ou # dsigne
* le numro d'erreur a executer si le test est false,
* Pour un % effectue teste le flag utilisateur %, si le test
* est ngatif, depile l'objet situ au niveau 2, sinon revient
*  l'excution normale, ceci permet un programme du type
* { ONE TWO &$ DISPROW1 } %1 ERR$EVALext qui affiche la concatnation
* des messages 1 et 2 lorsque le flag 1 est arm.
* Sinon excute le programme, la liste ou le symbolique
* (EVAL de chaque objet) mais pour les entiers
* systmes non taggus, remplace ces entiers par #31400+# et
* excute JstGETTHEMESG (rappelle le message d'erreur # de ALGB)
* Exemple { ONE TWO &$ DISPROW1 } ERR$EVALext
* rappelle les messages 1,2 les concatne et affiche le rsultat
* en ligne 1.
* Attention, les NULLLAM sont dcals de 2 et les compteurs de
* boucles de 1
::
DUPTYPEREAL? IT :: COERCE TestUserFlag ?SEMI DROP RDROP ;
DUP TYPEBINT? case :: SWAP caseDROP AL#MSG #+ DO#EXIT ;
DUP1LAMBIND LENCOMP
#1+_ONE_DO (DO)
           1GETLAM INDEX@ NTHCOMPDROP DUPTYPEBINT?
           ITE :: AL#MSG #+ JstGETTHEMSG ; EVAL
           LOOP
ABND
;
*************************************************************
NULLNAME User1IT
* Execute l'objet au niveau 1  la manire de ERR$EVALext si UF1 est arm.
::
%1 ERR$EVALext
;
*****************************************************************
NULLNAME MENUext ( $6, $5, $4, $3, $2, $1  -> affichage du menu )
* Affiche les 6 chanes dans les 6 cases du menu
::
ZERO SIX
ZERO_DO (DO)
        ( strings, # )
        TWENTYTWO OVER#+ UNROTSWAP Str>Menu
        LOOP
DROP
;
**********************
NULLNAME BINDext ( # [ runstream # objets ] -> )
* Cre # variables locales contenant les # objets suivants du runstream
* Exemple TWO BINDext LAM2 LAM1
::
DUP#0_DO
        RSWAP 'R RSWAP
        SWAPLOOP
NULLLAM SWAP NDUPN {}N BIND
;
**************************************************************
NULLNAME ASOPext ( { poly2 } { poly1 } oprateur binaire --> { poly3 } )
* Effectue l'addition ou la soustraction de deux polynmes selon l'oprateur
* plac au niveau 1 de la pile
::
CK&DISPATCH1
# 110 EVAL
# 220 EVAL
# 210 EVAL
# 120 EVAL
any :: ' :: CK&DISPATCH1
            2LIST :: DUPLENCOMP ROT DUPLENCOMP ROT2DUP
                     :: #=case 2DROP
                        2DUP#> casedrop :: ROTSWAP #1- LRDMext SWAP ;
                        SWAPDROP #1- LRDMext
                        ;
                     INNERCOMP #1+ROLL INNERDUP
                     ZERO_DO (DO)
                             ( a1, ..., ap, cp+1, ..., cn, b1, ..., bp, #n )
                             get1 ROT 2GETEVAL OVER #1+UNROLL
                             LOOP
                     {}N
                     ;
            EIGHTY :: SWAPINCOMP get1 ROTSWAP 2GETEVAL SWAP {}N ;
            FIVE :: SWAP ONE{}N SWAP 2GETEVAL ;
            ZERO :: 1GETLAM EVAL ;
            ;
       SWAP { NULLLAM NULLLAM } BIND 2GETEVAL ABND
       ;
;
*****************************************************************
NULLNAME MEVALext ( objet, 'o1=o2' -> remplace o1 par o2 dans objet )
*
::
DUPTYPESYMB? NcaseTYPEERR
xOBJ\-> EQ: x= SWAP %2 %= AND NcaseTYPEERR
' :: CK&DISPATCH1
     list LISTSECOext
     symb :: LISTSECOext FOURTEEN TestUserFlag NOT?SEMI
             CSQRext ?SEMI
             ELMGext CALCext ELMGext
             ;
     idnt :: 3GETLAM OVER EQUALcasedrp 2GETLAM ;
     any NOP
     ;
4NULLLAM{} CDRCOMP BIND 1GETLAM EVAL ABND
;
**************
NULLNAME HORNext ( polynome-liste P, r -> P[X] div [X-r], r, P[r] )
* Schma de Horner
::
OVER LENCOMP
#1=case :: SWAPINCOMP DROPDUP %0 MULText ONE{}N UNROT
           ;
TOLISText SIXTEEN SWAP
ITE :: SetUserFlag UNROT
       ( r, poly, lvar )
       DUPINCOMP reversym
       DUP #3+ ROLLSWAP
       ZERO_DO (DO)
               SWAP VXXLext
               LOOP
       TRIMext  ROT
       ( lvar, poly, r )
       ;
    ClrUserFlag
SWAPINCOMP  ( stack= r, a0, .., an, #n+1)
DUP #2+PICK
( r, a0, ..., an, #n+1, r )
SWAP get1
( r, a1, ..., an, r, #n+1, a0)
DUP4UNROLL
( r, a1, ...., an, b0, r, #n+1 , a0)
:: CK&DISPATCH1
   SIXTYTHREE :: DROPDUP
                 ONE_DO  (DO)
                         ( r, ak,...,an, b0, b1, ..., bk-1, r, #n+1 )
                         get1
                         ( 4PICK 4PICK %%* %%+ )
CODE ( stk1 -> stk1- stk4*stk3 )
    GOSBVL =POP1%%   ( dpile n1 -> %% )
    C=B W  ( sauvegards dans R3=A, R4=B )
    R4=C W
    R3=A W
    GOSBVL =GETPTR
    D1=D1+ 10 ( D1=@@stk4 )
    A=DAT1 A  ( A=@stk4 )
    AD1EX  ( D1= @stk4, A=@@stk4 )
    D1=D1+ 10 ( skip prolog )
    C=DAT1 W
    D=C W
    D=0 S
    D1=D1- 5
    C=DAT1 A
    RSTK=C
    D1=A A ( D1=@@stk4 )
    D1=D1- 5 ( D1=@@stk3 )
    C=DAT1 A ( C=@stk3 )
    D1=C A ( D1=@stk3 )
    D1=D1+ 10 ( skip prolog )
    A=DAT1 W
    B=A W
    B=0 S
    D1=D1- 5
    A=DAT1 A
    C=RSTK
    SETDEC

    HS=0 3
    GOSBVL =MULTF   ( %%* )
    C=R4 W
    D=C W
    C=R3 W
    HS=0 3
    GOSBVL =RADDF   ( %%+ )
    GOVLNG =PUSH%%LOOP  ( -> n1 et rpl inner loop)
ENDCODE
                         UNROT
                         LOOP
                         ;
any :: 3PICK CSQRext
       ITE :: ' x*  RESOROMP LOPAext 2Ob>Seco ;
           :: RESOROMP MPMULText ;
       RESOROMP RADDext
       RESOROMP ASOPext
       4NULLLAM{} CDRCOMP BIND
       2DROP DUP
       ONE_DO (DO)
              ( r, ak,...,an, b0, b1, ..., bk-1, r, #n+1 )
              get1 4PICK 4PICK 3GETLAM EVAL 2GETLAM 1GETLAM EVAL
              UNROT
              LOOP
       ABND
       ;
 ;
( r, b0, b1, ..., bn, r, #n+1)
UNROTDROP
( r, b0, ..., bn-1, #n+1, bn )
OVER #1+UNROLL #1-{}N
( r, bn , {b0 ... bn-1 } )
UNROT
SIXTEEN TestUserFlag NOT?SEMI
( var, B, r, bn ) 4PICK VALext SWAP 4PICK VALext
SWAPROT 4ROLL VALext UNROT SIXTEEN ClrUserFlag
;
**************
NULLNAME PTAYLext
( polynme-liste P, r -> dvpt Taylor de P en r )
( P r )
::
OVER LENCOMP
( P r #n )
DUP4UNROLL
ZERO_DO (DO)
        HORNext 4UNROLL
        LOOP
2DROP reversym {}N
;
**************
NULLNAME BAIRSText
( polynome-liste P, s ,p -> P[X] div [X*X-sX+p], s, p, R[X-s] )
* Division euclidienne par un polynome quadratique
::
ROT INNERDUP
#>2case
:: ( s,p, a0, ..., an, #n+1 )
   DUPROLL
   ( s,p, a0, a2, ..., #n+1, a1 )
   OVER #1+ROLL
   ( s, p, a2, ..., #n+1, a1, a0 )
   UNROTSWAP
   ( s, p, a2, ..., an, a0, a1, #n+1 )
   #3+ DUPPICK
   ( s, p, a2, ..., an, a0, a1, #n+4, s )
   ROTOVER
   ( s, p, a2, ..., an, a0, #n+4, s , a1, s )
   5PICK
   ( s, p, a2, ..., an, a0, #n+4, s , a1 , s , a0 )
* Plus de controle de type, assume %%
*   :: CK&DISPATCH1
*   #3F3F ::
            %%* %%+ UNROTOVER
            ( s, p, a2, ..., an, b0, b1, #n+4, s, #n+4)
            PICK
            ( s, p, a2, ..., an, b0, b1, #n+4, s, p)
            ROTDUP
            FIVE
            DO
               ( stack = ak, ..., an, b0,..., bk-1, s, p, #n+4 )
               DUPROLL
               ( 6PICK 4PICK %%* %%- 5PICK 5PICK %%* %%+ )
               CODE ( stk1 -> stk1- stk6*stk3+stk5*stk4 )
               GOSBVL =POP1%%   ( dpile n1 -> %% )
               C=B W  ( sauvegards dans R3=A, R4=B )
               R4=C W
               R3=A W
               GOSBVL =GETPTR
               D1=D1+ 5 ( D1=@@stk3 )
               A=DAT1 A  ( A=@stk3 )
               AD1EX  ( D1= @stk3, A=@@stk3 )
               D1=D1+ 10 ( skip prolog )
               C=DAT1 W
               D=C W
               D=0 S
               D1=D1- 5
               C=DAT1 A
               RSTK=C
               D1=A A ( D1=@@stk3 )
               D1=D1+ 15 ( D1=@@stk6 )
               C=DAT1 A ( C=@stk6 )
               D1=C A ( D1=@stk6 )
               D1=D1+ 10 ( skip prolog )
               A=DAT1 W
               B=A W
               B=0 S
               D1=D1- 5
               A=DAT1 A
               C=RSTK
               SETDEC

               HS=0 3
               GOSBVL =MULTF   ( %%* )
               C=R4 W
               D=C W
               C=R3 W
               A=-A-1 S        ( %%CHS )
               HS=0 3
               GOSBVL =RADDF   ( %%+ )

               C=B W   ( sauvegarde R4=B, R3=A )
               R4=C W
               R3=A W
               GOSBVL =GETPTR ( stk4 et stk3 -> A et C)
               D1=D1+ 10 ( D1=@@stk3 )
               A=DAT1 A  ( A=@stk3 )
               AD1EX  ( D1= @stk3, A=@@stk3 )
               D1=D1+ 10 ( skip prolog )
               C=DAT1 W
               D=C W
               D=0 S
               D1=D1- 5
               C=DAT1 A
               RSTK=C
               D1=A A ( D1=@@stk3 )
               D1=D1+ 5 ( D1=@@stk4 )
               C=DAT1 A ( C=@stk4 )
               D1=C A ( D1=@stk4 )
               D1=D1+ 10 ( skip prolog )
               A=DAT1 W
               B=A W
               B=0 S
               D1=D1- 5
               A=DAT1 A
               C=RSTK

               SETDEC
               HS=0 3
               GOSBVL =MULTF   ( %%* )
               HS=0 3
               C=R4 W
               D=C W
               C=R3 W
               GOSBVL =RADDF   ( %%+ )
               GOVLNG =PUSH%%LOOP  ( -> n1 et rpl inner loop)
               ENDCODE
               4UNROLL
               LOOP
*            ;
*   any  :: RMULText RADDext UNROTOVER
*           ( s, p, a2, ..., an, b0, b1, #n+4, s, #n+4)
*           PICK
*           ( s, p, a2, ..., an, b0, b1, #n+4, s, p)
*           ROTDUP
*           FIVE
*           DO
*               ( stack = ak, ..., an, b0,..., bk-1, s, p, #n+4 )
*               DUPROLL 6PICK 4PICK RMULText RSUBext 5PICK 5PICK
*               RMULText RADDext 4UNROLL
*               LOOP
*           ;
*   ;
   ( stack = s, p, b0, ..., bn, s, p, #n+4 )
   #5- UNROT2DROP
   ( stack = s, p, b0, ..., bn , #n-1  )
   UNROT TWO{}N
   ( stack = s, p, b0, ..., bn-2, #n-1, { bn-1 bn} )
   OVER#2+UNROL
   ( stack = s, p, {bn-1 bn}, b0, ..., bn-2, #n-1 )
   {}N 4UNROLL
   ;
#1=case :: ( s, p, a0) %0 SWAP TWO{}N %0 ONE{}N 4UNROLL ;
( s p a0 a1)
%0 ONE{}N 5UNROLL OVER5PICK
( s p a0 a1 a0 s )
* :: CK&DISPATCH1
*   #3F3F ::
             %%* %%+
*            ;
*   any :: x* x+ ;
*   ;
TWO{}N
;
**************
NULLNAME DTYPFMAT? ( objet -> objet TRUE ou -> objet FALSE )
* Teste si on a affaire  une matrice formelle
::
DUPNULL{}? caseFALSE
NOTLISTcase FALSE
DUPINCOMP OVER
NOTLISTcase :: DROPNDROP FALSE ;
LENCOMP
DUP#0=csedrp 2DROPFALSE
TRUE ROT
ZERO_DO (DO)
        ( l1,..., ln, #lenl1, flag )
        ROT DTYPELIST?
        ITE :: LENCOMP 3PICK #= ;
            DROPFALSE
        AND
        LOOP
SWAPDROP
;
**************
NULLNAME DTYPENDO? ( objet -> objet TRUE ou FALSE )
* Teste si objet est la matrice d'un endomorphisme (matrice carre)
::
AXLext DTYPFMAT? NOTcaseFALSE
DUPLENCOMP OVER CARCOMP LENCOMP #=
;
**************
NULLNAME CK2FPOLY ( -> )
* teste les niveaux 1 et 2 de la pile, si une liste vide est rencontre
* sinon Bad Argument Value
::
DUPNULL{}? caseSIZEERR OVER DUPNULL{}? caseSIZEERR DROP
;
***************
NULLNAME LISTSECOext ( list, seco ou symb -> list, seco, symb )
* Excute 1GETLAM sur les composants de list ou de seco
::
DUP
INNERDUP #0=?SEMI
DUP#0_DO
       DUP #1+ROLL 1GETLAM EVAL
       SWAPLOOP
get1 DTYPELIST? casedrop {}N
TYPESYMB? case SYMBN ::N
;
***************
NULLNAME RADDext ( o2, o1 -> somme )
::
CK&DISPATCH1
2REAL %+
THIRTYFOUR x+
EIGHTEEN x+
THIRTYTHREE x+
TWENTY :: ( real + matrix )
          DUP UIDN ROT x* x+
          ;
THIRTYSIX :: ( cmp + matrix )
             DUP UIDN ROT x* x+
             ;
# 3F3F %%+
# 1F1F #+
any :: FOURTEEN TestUserFlag NOTcase x+
       2DUP x+ CSQRext
       case UNROT2DROP
       UNROT
       CK&DISPATCH1
       SYMSYM :: ROTDROP FXNDext ROT FXNDext 3PICKOVER x* 5UNROLL
                 ( d1*d2, n1,d1,n2,d2 ) SWAPROT x*
                 ( d1*d2, n1, d2, n2*d1 )
                 UNROT x* x+ SWAP SIMPext NDXFext
                 ;
       SYMOB :: ROTDROP SWAP FXNDext ROTOVER x* ROTSWAP x+ SWAP SIMPext NDXFext ;
       sym :: ROTDROP FXNDext ROTOVER x* ROT x+ SWAP SIMPext NDXFext ;
       any 2DROP
       ;
;
**************
NULLNAME RSUBext ( o2, o1 -> diffrence )
::
CK&DISPATCH1
2REAL %-
THIRTYFOUR x-
# 3F3F %%-
# 1F1F #-
any :: FOURTEEN TestUserFlag NOTcase x-
       2DUP x- CSQRext
       case UNROT2DROP
       UNROT
       CK&DISPATCH1
       SYMSYM :: ROTDROP FXNDext ROT FXNDext 3PICKOVER x* 5UNROLL
                 ( d1*d2, n1,d1,n2,d2 ) SWAPROT x*
                 ( d1*d2, n1, d2, n2*d1 )
                 UNROT x* x- SWAP SIMPext NDXFext
                 ;
       SYMOB :: ROTDROP SWAP FXNDext ROTOVER x* ROTSWAP x- SWAP SIMPext NDXFext ;
       sym :: ROTDROP FXNDext ROTOVER x* ROT x- SWAP SIMPext NDXFext ;
       any 2DROP
       ;
;
**************
NULLNAME RMULText
::
CK&DISPATCH1
2REAL %*
THIRTYFOUR x*
# 3F3F %%*
# 1F1F #*
# 1F1 :: COERCE #* ;
# 11F  :: SWAP COERCE #* ;
# 3F1 :: %>%% %%* ;
any :: FOURTEEN TestUserFlag NOTcase x*
       2DUP x* CSQRext
       case UNROT2DROP
       UNROT
       CK&DISPATCH1
       SYMSYM :: ROTDROP FXNDext ROT FXNDext 4ROLLSWAP ( d2, n1, n2, d1 )
                 UNROT x* UNROT x* SIMPext NDXFext
                 ;
       SYMOB :: ROTDROP SWAP FXNDext UNROT x* SWAP SIMPext NDXFext ;
       sym :: ROTDROP FXNDext UNROT x* SWAP SIMPext NDXFext ;
       any 2DROP
       ;
;
****************
NULLNAME RDIVext
::
CK&DISPATCH1
# 3F3F %%/
# 1F1F :: #/ DROP ;
list :: SIMPext ' U/ THREE SYMBN ;
any :: FIFTEEN TestUserFlag FOURTEEN TestUserFlag AND NOTcase U/
       2DUP U/ CSQRext
       case UNROT2DROP
       DROP
       CK&DISPATCH1
       SYMSYM :: FXNDext ROT FXNDext UNROT 4ROLL
                 ( d1, d2, n1, n2 )
                 UNROT x* UNROT x* SIMPext NDXFext
                 ;
       SYMOB :: SWAP FXNDext ROT x* SIMPext NDXFext ;
       sym :: FXNDext ROT x* SWAP SIMPext NDXFext ;
       any :: SIMPext NDXFext ;
       ;
;
*******************
NULLNAME MPext ( objet, #entier, prg de multiplication -> objet^#entier )
::
UNROT DUPTYPEREAL? IT %ABSCOERCE
:: OVER CK&DISPATCH1
   list :: DTYPENDO? ITE %1 { %1 } ;
   THIRTYONE ONE
   SIXTYTHREE %%1
   any %1
   ;
SWAPDROPSWAP ( prg, A, I, # )
[BEGIN]
( prg, A^[2^k], result , # )
DUP#0<>WHILE
:: TWO #/
   ( prg, A^[2^k], result, remainder, quotient )
   4UNROLL
   #0=?SKIP :: ( prg, quotient, A^[2^k], result ) OVER5PICK EVAL ;
   ( prg, quotient, A^[2^k], result )
   3PICK #0=case ROT
   SWAPDUP 5PICK EVAL SWAPROT
   ;
[REPEAT]
DROP UNROT2DROP
;
*******************
NULLNAME TOLISText ( algbrique -> variables, liste, TRUE ou
                   (               algbrique, FALSE )
* Si l'algbrique contient des variables globales, transforme en
* polynme-liste (ventuellement  plusieurs variables)
::
CK&DISPATCH1
real FALSE
TWO FALSE
SIXTYTHREE FALSE
any :: DUP LVARext DUPINCOMP reversym
       DUP#0=csedrp DROPFALSE
       DUP #3+ ROLLSWAP
       ZERO_DO (DO)
               SWAP VXXLext
               LOOP
       TRIMext TRUE
       ;
;
*********************
NULLNAME RMSYMext ( objet -> symbolique )
* Elimine les symboles imbriqus
::
TWO BINDext
:: DUPTYPESYMB?
   case :: INNERCOMP
           ZERO_DO (DO)
                   2GETEVAL
                   LOOP
           ;
   1GETLAM SWAP >TCOMP 1PUTLAM
   ;
NULL{} ( liste vide pour entamer la recursivit )
2GETEVAL 1GETABND
( liste avec les composants  l'envers )
( elminination des i et remplacement par des C% 0 1 )
INNERCOMP SYMBOL ; SWAP
ZERO_DO (DO)
        :: SWAP REQcasedrop xi C% 0 1
           ;
        >TCOMP
        LOOP
;
************************
NULLNAME MADJext ( matrice M -> M^-1, P[M], P[lambda] )
* Calcule le polynme caractristique et le polynme matrice adjoint
* d'une matrice donne.
::
DUPTYPELIST?
ITE :: ( matrice-liste )
       ( teste le flag 17, s'il n'est pas mis, transforme )
       ( en liste les paramtres si ncessaire )
       SIXTEEN ClrUserFlag SEVENTEEN TestUserFlag
       ?SKIP :: TOLISText NOT?SEMI SIXTEEN SetUserFlag SWAP 1LAMBIND
                ;
       ( A )
       NULL{} { %1 } ROT DUPLENCOMP
       ( {}, { %1 }, A, #n )
       DUP UNCOERCE xIDN AXLext DUP4UNROLL SWAP
       ( {}, { %1 }, I_n, A, I_n, #n+1 )
       #1+_ONE_DO (DO)
                  ( pmadj , pcar , I_n, A, A_k-1 )
                  ( complete pmadj )
                  5ROLL OVER
                  SIXTEEN TestUserFlag INDEX@ #1<> AND IT :: 1GETLAM VALext ;
                  >TCOMP 5UNROLL
                  ( pmadj , pcar , I_n, A, A_k-1 )
                  OVER MMULText DUP TRext
                  ( pmadj , pcar , I_n, A, A_k-1*A, tr[A_k-1*A] )
                  INDEX@ UNCOERCE %CHS ' RDIVext LOPAext
                  ( pmadj , pcar , I_n, A, A_k-1*A, -tr[A_k-1*A]/k )
                  ( complete pcar )
                  5ROLL OVER
                  SIXTEEN TestUserFlag IT :: 1GETLAM VALext ;
                  >TCOMP 5UNROLL
                  ( pmadj , pcar , I_n, A, A_k-1*A, -tr[A_k-1*A]/k )
                  4PICKSWAP ' MULText LOPAext ADDext
                  ( pmadj , pcar , I_n, A, A_k=A_k-1*A-tr[A_k-1*A]/k*I_n )
                  LOOP
       SIXTEEN TestUserFlag NOT?SEMI ABND SIXTEEN ClrUserFlag
       ;
    :: ( array )
       DUP MDIMS NcaseSIZEERR
       OVER#= NcaseSIZEERR
       ( A, #n )
       NULL{} { %1 } 4ROLL DUP xIDN DUPUNROT
       6ROLL
       ( {}, { %1 }, I_n, A, I_n, #n )
       #1+_ONE_DO (DO)
                  5ROLL OVER >TCOMP 5UNROLL OVER x* DUP
                  TRext INDEX@ UNCOERCE x/ xNEG 5ROLL OVER >TCOMP
                  5UNROLL 4PICK x* x+
                  LOOP
       ;
( pmadj , pcar , I_n, A, A_n=det[A]*I_n )
3DROP 2DUPSWAP
( pmadj, pcar, pcar, pmadj )
DUPLENCOMP NTHCOMPDROP
( pmadj, pcar, pcar, com[A] )
SWAP DUPLENCOMP NTHCOMPDROP
( pmadj, pcar, com[A], -det[A] )
%-1 SWAPDUP %0 EQUAL ITE NDXFext RDIVext
( pmadj, pcar, com[A], '1/det[A]' )
DECOMP$ >TAG UNROT
( TAGGED '1/det[A]' com[A], pmadj, pcar )
;
*******************
NULLNAME DEPTHext ( objet -> # )
* renvoie la profondeur maximale d'un objet
::
THREE BINDext
ZERO ZERO
:: NOTLISTcase DROP
     2GETLAM #1+DUP 2PUTLAM
     3GETLAM OVER
     #<ITE 3PUTLAM DROP
     INNERCOMP
     ZERO_DO (DO)
             1GETLAM EVAL
             LOOP
     2GETLAM #1- 2PUTLAM
     ;
1GETLAM EVAL
3GETLAM ABND
( fin de DEPTH )
;
**********************
NULLNAME NULext ( -> element neutre )
* Renvoie l'lment neutre courant, selon le UserFlag 10:
* 0 pour les entiers ou { 0 } pour les polynmes.
::
TEN UserITE %0 { %0 }
;
*********************
NULLNAME Xiext ( objet -> objet )
* Ecrit les complexes sous forme formelle (a,b) -> a+i*b
::
' :: CK&DISPATCH1
     TWO :: C%>% SYMBOL xi ; x* x+
            ;
     list LISTSECOext
     symb LISTSECOext
     any NOP
     ;
DUP1LAMBIND EVAL ABND
;
***********************